<?php
// $Id: pnadminapi.php,v 1.2 2003/06/12 07:29:12 larsneo Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Nathan Welch
// Purpose of file:  PayPalCart administration API
// ----------------------------------------------------------------------


// Create a new item
function paypalcart_adminapi_createitem($args) {

    // Get arguments
    extract($args);

    // Argument check
		if (!isset($prod_name) || !isset($amount) || !is_numeric($amount) || !isset($cid) || !is_numeric($cid)) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }
		
		 if ($image == 'transparent.png')
			    $image = '';
					
		 if ($image_th == 'transparent.png')
			    $image_th = '';							

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Product:Edit', '::', ACCESS_ADD) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_ADD)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];
		
    // Get order for newly created item (make last in line) (count existing items for this category)    
    $sql = "SELECT $ppc_items_column[pid] FROM $ppc_items_table WHERE $ppc_items_column[cid] = $cid";
    $result = $dbconn->Execute($sql);
    $order = $result->PO_RecordCount();			
    $result->Close();				
    $order++;				
		
    // Get next ID in table
    $nextId = $dbconn->GenId($ppc_items_table);

    $sql = "INSERT INTO $ppc_items_table (
              $ppc_items_column[pid],			
              $ppc_items_column[cid],		
              $ppc_items_column[name],
              $ppc_items_column[sku],
              $ppc_items_column[desc],
              $ppc_items_column[amount],
              $ppc_items_column[option1],	
              $ppc_items_column[option2],	
              $ppc_items_column[shipping],	
              $ppc_items_column[shipping2],	
              $ppc_items_column[handling],	
              $ppc_items_column[active],	
              $ppc_items_column[image_th],	
              $ppc_items_column[image],																																																																							
              $ppc_items_column[order])
            VALUES (
              $nextId,
              '" . pnVarPrepForStore($cid) . "',
              '" . pnVarPrepForStore($prod_name) . "',
              '" . pnVarPrepForStore($sku) . "',
              '" . pnVarPrepForStore($desc) . "',
              '" . pnVarPrepForStore($amount) . "',
              '" . pnVarPrepForStore($option1) . "',
              '" . pnVarPrepForStore($option2) . "',
              '" . pnVarPrepForStore($shipping) . "',
              '" . pnVarPrepForStore($shipping2) . "',
              '" . pnVarPrepForStore($handling) . "',																																																								
              '" . pnVarPrepForStore($active) . "',	
              '" . pnVarPrepForStore($image_th) . "',		
              '" . pnVarPrepForStore($image) . "',																											
              '" . pnvarPrepForStore($order) . "')";
    $dbconn->Execute($sql);

    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CREATEITEMFAILED);
        return false;
    }

    // Get the ID of the item that we inserted.
    $pid = $dbconn->PO_Insert_ID($ppc_items_table, $ppc_items_column['pid']);

    return $pid;
}



// Update an item
function paypalcart_adminapi_updateitem($args) {

    // Get arguments
    extract($args);

    // Argument check
		if (!isset($prod_name) || !isset($cid)  || !is_numeric($cid)  || !isset($old_cid)  || !is_numeric($old_cid)  || !isset($pid) || !is_numeric($pid) || !isset($amount) ||  !is_numeric($amount)) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }
		
		 if ($image == 'transparent.png')
			    $image = '';
					
		 if ($image_th == 'transparent.png')
			    $image_th = '';				

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$old_cid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];
		
		
        $sql = "UPDATE $ppc_items_table
		        SET $ppc_items_column[cid] = '".pnVarPrepForStore($cid)."',	
                  $ppc_items_column[name] = '".pnVarPrepForStore($prod_name)."',	
                  $ppc_items_column[sku] = '".pnVarPrepForStore($sku)."',	
                  $ppc_items_column[desc] = '".pnVarPrepForStore($desc)."',	
                  $ppc_items_column[amount] = '".pnVarPrepForStore($amount)."',	
                  $ppc_items_column[option1] = '".pnVarPrepForStore($option1)."',	
                  $ppc_items_column[option2] = '".pnVarPrepForStore($option2)."',	
                  $ppc_items_column[shipping] = '".pnVarPrepForStore($shipping)."',	
                  $ppc_items_column[shipping2] = '".pnVarPrepForStore($shipping2)."',	
                  $ppc_items_column[handling] = '".pnVarPrepForStore($handling)."',	
                  $ppc_items_column[active] = '".pnVarPrepForStore($active)."',	
                  $ppc_items_column[image_th] = '".pnVarPrepForStore($image_th)."',																																																																																		
                  $ppc_items_column[image] = '".pnVarPrepForStore($image)."'
				    			WHERE $ppc_items_column[pid] = '".pnVarPrepForStore($pid)."'";		
									
						

    $dbconn->Execute($sql);

    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_UPDATEITEMFAILED);
        return false;
    }
		
		// If item was moved to category, make it the last item in the new category
		// And adjust the order of the items in the old category
		if ($old_cid != $cid) {
		
        // Get the info for this item
        $rows = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);
		    extract($rows);				
        
		    // Update order of all items "above" the deleted one
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = ($ppc_items_column[order] - 1)
                WHERE $ppc_items_column[order] > '$order' AND $ppc_items_column[cid] = '$old_cid'";				
				
				$dbconn->Execute($sql);

        // Check for an error with the database code.
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _PPC_UPDATEITEMFAILED);
            return false;
       }					
		
        // Get order for newly created item (make last in line) (count existing items for this category)    
        $sql = "SELECT $ppc_items_column[pid] FROM $ppc_items_table WHERE $ppc_items_column[cid] = $cid";
        $result = $dbconn->Execute($sql);
        $order = $result->PO_RecordCount();			
        $result->Close();	
				
        // Make updated item the last item (equal to count) of the new category
				$sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = '$order' WHERE $ppc_items_column[pid] = '".pnVarPrepForStore($pid)."'";		
									
        $dbconn->Execute($sql);

        // Check for an error with the database code.
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', _PPC_UPDATEITEMFAILED);
            return false;
       }	
			 
		}

    return $pid;
}


// Delete an item
function paypalcart_adminapi_deleteitem($args) {

    // Get arguments
    extract($args);

    // Argument check
    if (!isset($pid) || !is_numeric($pid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		
    // Get the info for this item
    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);
		extract($rows);					

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_DELETE) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];
		
    // Remove selected item from dbase
    $sql = "DELETE FROM $ppc_items_table WHERE $ppc_items_column[pid]='".pnVarPrepForStore($pid)."'";
    $dbconn->Execute($sql);
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETEITEMFAILED);
        return false;
    }		
		
		// Update order of all items "above" the deleted one
    $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = ($ppc_items_column[order] - 1)
            WHERE $ppc_items_column[order] > '$order' AND $ppc_items_column[cid] = '$cid'";
						
    $dbconn->Execute($sql);	
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETEITEMFAILED);
        return false;
    }				

    return true;
}


// Create a new category
function paypalcart_adminapi_createcategory($args) {

    // Get arguments
    extract($args);

    // Argument check
		if (!isset($cat_name) || !isset($itemcolumns) || !is_numeric($itemcolumns) || !$itemcolumns) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }
		
		 if ($image == 'transparent.png')
			    $image = '';

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', '::', ACCESS_ADD)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];
		
    // Get order for newly created category (make last in line) (count existing categories)    
    $sql = "SELECT $ppc_categories_column[cid] FROM $ppc_categories_table";
    $result = $dbconn->Execute($sql);
    $order = $result->PO_RecordCount();			
    $result->Close();				
    $order++;				
		
    // Get next ID in table
    $nextId = $dbconn->GenId($ppc_categories_table);

    $sql = "INSERT INTO $ppc_categories_table (
              $ppc_categories_column[cid],		
              $ppc_categories_column[name],
              $ppc_categories_column[desc],
              $ppc_categories_column[itemcolumns],							
              $ppc_categories_column[active],	
              $ppc_categories_column[image],								
              $ppc_categories_column[order])
            VALUES (
              $nextId,
              '" . pnVarPrepForStore($cat_name) . "',
              '" . pnVarPrepForStore($desc) . "',
              '" . pnVarPrepForStore($itemcolumns) . "',							
              '" . pnVarPrepForStore($active) . "',	
              '" . pnVarPrepForStore($image) . "',								
              '" . pnvarPrepForStore($order) . "')";
    $dbconn->Execute($sql);

    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CREATECATEGORYFAILED);
        return false;
    }

    // Get the ID of the category that we inserted.
    $cid = $dbconn->PO_Insert_ID($ppc_categories_table, $ppc_categories_column['cid']);

    return $cid;
}


// Update a category
function paypalcart_adminapi_updatecategory($args) {

    // Get arguments
    extract($args);

    // Argument check
		if (!isset($cat_name) || !isset($cid) || !is_numeric($cid) || !isset($itemcolumns) || !is_numeric($itemcolumns)) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }
		
		 if ($image == 'transparent.png')
			    $image = '';		

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];
		
        $sql = "UPDATE $ppc_categories_table
		        SET $ppc_categories_column[name] = '".pnVarPrepForStore($cat_name)."',	
                  $ppc_categories_column[desc] = '".pnVarPrepForStore($desc)."',	
                  $ppc_categories_column[itemcolumns] = '".pnVarPrepForStore($itemcolumns)."',										
                  $ppc_categories_column[active] = '".pnVarPrepForStore($active)."',	
                  $ppc_categories_column[image] = '".pnVarPrepForStore($image)."'
				    			WHERE $ppc_categories_column[cid] = '".pnVarPrepForStore($cid)."'";

    $dbconn->Execute($sql);

    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_UPDATECATEGORYFAILED);
        return false;
    }

    return $cid;
}

// Delete a category
function paypalcart_adminapi_deletecategory($args) {

    // Get arguments
    extract($args);

    // Argument check
    if (!isset($cid) || !is_numeric($cid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];
		
    // Get the info for this item
    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getcategory', $cid);
		extract($rows);						
	
    // Remove selected category from dbase
    $sql = "DELETE FROM $ppc_categories_table WHERE $ppc_categories_column[cid]='".pnVarPrepForStore($cid)."'";
    $dbconn->Execute($sql);
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETECATEGORYFAILED);
        return false;
    }			

		// Update order of all categories "above" the deleted one
    $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = ($ppc_categories_column[order] - 1)
            WHERE $ppc_categories_column[order] > '$order'";
						
    $dbconn->Execute($sql);	
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETECATEGORYFAILED);
        return false;
    }		

		
    // Remove items belonging to this category from dbase
    $sql = "DELETE FROM $ppc_items_table WHERE $ppc_items_column[cid]='".pnVarPrepForStore($cid)."'";
    $dbconn->Execute($sql);
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETEITEMFAILED);
        return false;
    }		


    return true;
}



// Create a new option
function paypalcart_adminapi_createoption($args) {

    // Get arguments
    extract($args);

    // Argument check
		if (!isset($opt_name) || !isset($label) || !isset($style)) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Option:Edit', '::', ACCESS_ADD)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_options_table = $pntable['paypalcart_options'];
    $ppc_options_column = &$pntable['paypalcart_options_column'];
		
    // Get next ID in table
    $nextId = $dbconn->GenId($ppc_options_table);

    $sql = "INSERT INTO $ppc_options_table (
              $ppc_options_column[oid],		
              $ppc_options_column[name],
              $ppc_options_column[label],
              $ppc_options_column[style],							
              $ppc_options_column[desc])
            VALUES (
              $nextId,
              '" . pnVarPrepForStore($opt_name) . "',
              '" . pnVarPrepForStore($label) . "',
              '" . pnVarPrepForStore($style) . "',							
              '" . pnvarPrepForStore($desc) . "')";
    $dbconn->Execute($sql);

    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CREATEOPTIONFAILED);
        return false;
    }

    // Get the ID of the option that we inserted.
    $oid = $dbconn->PO_Insert_ID($ppc_options_table, $ppc_options_column['oid']);

    return $oid;
}


// Update an option
function paypalcart_adminapi_updateoption($args) {

    // Get arguments
    extract($args);

    // Argument check
		if (!isset($oid) || !is_numeric($oid) || !isset($opt_name) || !isset($label) || !isset($style) || !is_numeric($style)) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_options_table = $pntable['paypalcart_options'];
    $ppc_options_column = &$pntable['paypalcart_options_column'];
		
        $sql = "UPDATE $ppc_options_table
		        SET $ppc_options_column[name] = '".pnVarPrepForStore($opt_name)."',	
                  $ppc_options_column[label] = '".pnVarPrepForStore($label)."',	
                  $ppc_options_column[style] = '".pnVarPrepForStore($style)."',									
                  $ppc_options_column[desc] = '".pnVarPrepForStore($desc)."'
				    			WHERE $ppc_options_column[oid] = '".pnVarPrepForStore($oid)."'";

    $dbconn->Execute($sql);

    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_UPDATEOPTIONFAILED);
        return false;
    }

    return $oid;
}

// Delete an option
function paypalcart_adminapi_deleteoption($args) {

    // Get arguments
    extract($args);

    // Argument check
    if (!isset($oid) || !is_numeric($oid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		
    $ppc_options_table = $pntable['paypalcart_options'];
    $ppc_options_column = &$pntable['paypalcart_options_column'];
    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];				
	
    // Remove selected option from dbase
    $sql = "DELETE FROM $ppc_options_table WHERE $ppc_options_column[oid]='".pnVarPrepForStore($oid)."'";
    $dbconn->Execute($sql);
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETEOPTIONFAILED);
        return false;
    }			
		
    // Remove option values belonging to this option from dbase
    $sql = "DELETE FROM $ppc_optionval_table WHERE $ppc_optionval_column[oid]='".pnVarPrepForStore($oid)."'";
    $dbconn->Execute($sql);
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETEOPTIONVALFAILED);
        return false;
    }		
		
    // Remove options from any product with it specified
    $sql = "UPDATE $ppc_items_table
		        SET $ppc_items_column[option1] = ''
						WHERE $ppc_items_column[option1] = '".pnVarPrepForStore($oid)."'";
    $dbconn->Execute($sql);					
		
    $sql = "UPDATE $ppc_items_table
		        SET $ppc_items_column[option2] = ''
						WHERE $ppc_items_column[option2] = '".pnVarPrepForStore($oid)."'";
    $dbconn->Execute($sql);								
		
    return true;
}



// Create a new option value
function paypalcart_adminapi_createoptionval($args) {

    // Get arguments
    extract($args);

    // Argument check
		if (!isset($value)) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', '::', ACCESS_ADD) || !pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_ADD)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

	
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];
		
    // Get order for newly created option value (make last in line) (count existing attributes for this option)    
    $sql = "SELECT $ppc_optionval_column[vid] FROM $ppc_optionval_table WHERE $ppc_optionval_column[oid] = '$oid'";
    $result = $dbconn->Execute($sql);
    $order = $result->PO_RecordCount();			
    $result->Close();				
    $order++;			
		
    // Get next ID in table
    $nextId = $dbconn->GenId($ppc_optionval_table);

    $sql = "INSERT INTO $ppc_optionval_table (
              $ppc_optionval_column[vid],		
              $ppc_optionval_column[oid],
              $ppc_optionval_column[value],
              $ppc_optionval_column[order])
            VALUES (
              $nextId,
              '" . pnVarPrepForStore($oid) . "',
              '" . pnVarPrepForStore($value) . "',
              '" . pnvarPrepForStore($order) . "')";
    $dbconn->Execute($sql);

    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CREATEOPTIONVALFAILED);
        return false;
    }

    // Get the ID of the option value that we inserted.
    $vid = $dbconn->PO_Insert_ID($ppc_optionval_table, $ppc_optionval_column['vid']);

    return $vid;
}


// Update an option value
function paypalcart_adminapi_updateoptionval($args) {

    // Get arguments
    extract($args);

    // Argument check
		if (!isset($vid) || !is_numeric($vid) || !isset($oid) || !is_numeric($oid) || !isset($value)) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$vid", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];
		
        $sql = "UPDATE $ppc_optionval_table
		        SET $ppc_optionval_column[oid] = '".pnVarPrepForStore($oid)."',	
                  $ppc_optionval_column[value] = '".pnVarPrepForStore($value)."'	
				    			WHERE $ppc_optionval_column[vid] = '".pnVarPrepForStore($vid)."'";

    $dbconn->Execute($sql);

    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_UPDATEOPTIONVALFAILED);
        return false;
    }

    return $vid;
}

// Delete an option value
function paypalcart_adminapi_deleteoptionval($args) {

    // Get arguments
    extract($args);

    // Argument check
    if (!isset($vid) || !is_numeric($vid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		
    // Get the info for this item
    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getoptionval', $vid);
		extract($rows);		

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$vid", ACCESS_DELETE) || !pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		
    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];	
	
    // Remove selected option value from dbase
    $sql = "DELETE FROM $ppc_optionval_table WHERE $ppc_optionval_column[vid]='".pnVarPrepForStore($vid)."'";
    $dbconn->Execute($sql);
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETEOPTIONVALFAILED);
        return false;
    }			
		
		// Update order of all items "above" the deleted one
    $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = ($ppc_optionval_column[order] - 1)
            WHERE $ppc_optionval_column[order] > '$order' AND $ppc_optionval_column[oid] = '$oid'";
						
    $dbconn->Execute($sql);	
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_DELETEOPTIONVALFAILED);
        return false;
    }					
	
    return true;
}


// Change status of category (inactive/active)
function paypalcart_adminapi_changecategorystatus($args) {
    
		// Get arguments
    extract($args);

    // Argument check
    if (!isset($cid) || !is_numeric($cid) || !isset($status)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Category:Active', "::$cid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }
		
		if ($status == 'inactive')
		    $active = '0';
		else
		    $active = '1';

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the category table & column names
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];		
				
		// Change status of category
    $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[active] = '$active' WHERE $ppc_categories_column[cid] = '".pnVarPrepForStore($cid)."'";		
		$dbconn->Execute($sql);
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CHANGECATSTATUSFAILED);
        return false;
    }				
		
    return true;
}


// Change status of category (inactive/active)
function paypalcart_adminapi_changeitemstatus($args) {
    
		// Get arguments
    extract($args);

    // Argument check
    if (!isset($pid) || !is_numeric($pid) || !isset($status)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		
		// Get the info for this item
   $rows = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);
	 extract($rows);				

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Product:Active', "::$pid", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }
		
		if ($status == 'inactive')
		    $active = '0';
		else
		    $active = '1';

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the item table & column names
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];		
				
		// Change status of item
    $sql = "UPDATE $ppc_items_table SET $ppc_items_column[active] = '$active' WHERE $ppc_items_column[pid] = '".pnVarPrepForStore($pid)."'";		
		$dbconn->Execute($sql);
		
    // Check for an error with the database code.
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_CHANGEITEMSTATUSFAILED);
        return false;
    }				
		
    return true;
}

// ORDERING FUNCTIONS

// Increase category position by one or move to bottom
function paypalcart_adminapi_inccategory($args) {
    
		// Get arguments
    extract($args);

    // Argument check
    if (!isset($cid) || !is_numeric($cid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Category:Order', "::$cid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the category table & column names
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];		

    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getcategory', $cid);		
		extract($rows);
				
		// Get count of total categories
    $sql = "SELECT $ppc_categories_column[cid] FROM $ppc_categories_table";
		$result = $dbconn->Execute($sql);
    $total_categories = $result->PO_RecordCount();	
		$result->Close();		
		
		if ($order >= $total_categories || $total_categories == 1) {
        pnSessionSetVar('errormsg', _PPC_MOVE_NONEBELOW);
        return false;
    }		
	
	  if ($tobot != '1') { // Move category down one position 
		
		    // Move ahead category down one position
        $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = $order WHERE $ppc_categories_column[order] = ($order + 1)";
        $dbconn->Execute($sql);
		
        // Move selected category up one position
        $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = ($order + 1) WHERE $ppc_categories_column[cid] = $cid";
		    $dbconn->Execute($sql);
		
		} else {  // Move category to bottom of list
		
		    // Move categories ahead of selected one down one position
        $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = ($ppc_categories_column[order] - 1) WHERE $ppc_categories_column[order] > '$order'";
        $dbconn->Execute($sql);
		
        // Move selected category top bottom of list
        $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = '$total_categories' WHERE $ppc_categories_column[cid] = $cid";
		    $dbconn->Execute($sql);		
		
		}
	 
    return true;
}

// Decrease category position by one or move to top
function paypalcart_adminapi_deccategory($args) {
    
		// Get arguments
    extract($args);

    // Argument check
    if (!isset($cid) || !is_numeric($cid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Category:Order', "::$cid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the category table & column names
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];		

    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getcategory', $cid);		
		extract($rows);		
		
		// Get count of total categories
    $sql = "SELECT $ppc_categories_column[cid] FROM $ppc_categories_table";
		$result = $dbconn->Execute($sql);
    $total_categories = $result->PO_RecordCount();	
		$result->Close();		

		if ($order == 1 || $total_categories == 1) {
        pnSessionSetVar('errormsg', _PPC_MOVE_NONEABOVE);
        return false;
    }		
		
	  if ($totop != '1') { // Move category up one position 		
	
	      // Move behind category up one position
        $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = $order WHERE $ppc_categories_column[order] = ($order - 1)";
        $dbconn->Execute($sql);
		
        // Move selected category down one position
        $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = ($order - 1) WHERE $ppc_categories_column[cid] = $cid";
        $dbconn->Execute($sql);
				
		} else {  // Move category to top of list
		
	      // Move behind categorys up one position
        $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = ($ppc_categories_column[order] + 1) WHERE $ppc_categories_column[order] < '$order'";
        $dbconn->Execute($sql);
		
        // Move selected category to first position
        $sql = "UPDATE $ppc_categories_table SET $ppc_categories_column[order] = '1' WHERE $ppc_categories_column[cid] = $cid";
        $dbconn->Execute($sql);
						
		}
			 
    return true;
}


// Increase item position by one or move to bottom
function paypalcart_adminapi_incitem($args) {
    
		// Get arguments
    extract($args);

    // Argument check
    if (!isset($pid) || !is_numeric($pid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		
		// Get the info for this item
   $rows = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);
	 extract($rows);			

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Product:Order', "::$pid", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the item table & column names		
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];		

    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);		
		extract($rows);
				
		// Get count of total items in that category
    $sql = "SELECT $ppc_items_column[pid] FROM $ppc_items_table WHERE $ppc_items_column[cid] = '$cid'";
		$result = $dbconn->Execute($sql);
    $total_items = $result->PO_RecordCount();	
		$result->Close();		
		
		if ($order >= $total_items || $total_items == 1) {
        pnSessionSetVar('errormsg', _PPC_MOVE_NONEBELOW);
        return false;
    }
		
	  if ($tobot != '1') { 	// Move item down one position			
	
	      // Move ahead item down one position
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = $order WHERE $ppc_items_column[order] = ($order + 1) AND $ppc_items_column[cid] = '$cid'";
        $dbconn->Execute($sql);
		
        // Move selected item up one position
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = ($order + 1) WHERE $ppc_items_column[pid] = $pid";
        $dbconn->Execute($sql);
								
		} else { 	 // Move item to bottom of list
		
	      // Move ahead item down one position
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = ($ppc_items_column[order] - 1) WHERE $ppc_items_column[order] > '$order' AND $ppc_items_column[cid] = '$cid'";
        $dbconn->Execute($sql);
				
        // Move selected item up one position
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = '$total_items' WHERE $ppc_items_column[pid] = $pid";		 	
				$dbconn->Execute($sql);
		
		}
		

    return true;
}

// Decrease item position by one or move to top
function paypalcart_adminapi_decitem($args) {
    
		// Get arguments
    extract($args);

    // Argument check
    if (!isset($pid) || !is_numeric($pid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		
		// Get the info for this item
   $rows = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);
	 extract($rows);			

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:Product:Order', "::$pid", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the item table & column names		
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];		

    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getproduct', $pid);		
		extract($rows);
		
		// Get count of total items in the category
    $sql = "SELECT $ppc_items_column[pid] FROM $ppc_items_table WHERE $ppc_items_column[cid] = '$cid'";
		$result = $dbconn->Execute($sql);
    $total_items = $result->PO_RecordCount();	
		$result->Close();		

		if ($order == 1 || $total_items == 1) {
        pnSessionSetVar('errormsg', _PPC_MOVE_NONEABOVE);
        return false;
    }	
		
	  if ($totop != '1') { 	 // Move item up one position 			
	
	      // Move behind item up one position
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = $order WHERE $ppc_items_column[order] = ($order - 1) AND $ppc_items_column[cid] = '$cid'";
        $dbconn->Execute($sql);
		
        // Move selected item down one position
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = ($order - 1) WHERE $ppc_items_column[pid] = $pid";
        $dbconn->Execute($sql);
				
		} else { 	 // Move item to top of list 	
		
	      // Move behind item up one position
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = ($ppc_items_column[order] + 1) WHERE $ppc_items_column[order] < '$order' AND $ppc_items_column[cid] = '$cid'";
        $dbconn->Execute($sql);
		
        // Move selected item down one position
        $sql = "UPDATE $ppc_items_table SET $ppc_items_column[order] = '1' WHERE $ppc_items_column[pid] = $pid";
        $dbconn->Execute($sql);	
	
		}		
			 
    return true;
}


// Increase optional value position by one or move to bottom
function paypalcart_adminapi_incoptionval($args) {
    
		// Get arguments
    extract($args);

    // Argument check
    if (!isset($vid) || !is_numeric($vid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		
		// Get the info for this item
   $rows = pnModAPIFunc('PayPalCart', 'admin', 'getoptionval', $vid);
	 extract($rows);				

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Order', "::$vid", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the option value table & column names		
    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];	

    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getoptionval', $vid);		
		extract($rows);
				
		// Get count of total option values in this attribute
    $sql = "SELECT $ppc_optionval_column[vid] FROM $ppc_optionval_table WHERE $ppc_optionval_column[oid] = $oid";
		$result = $dbconn->Execute($sql);
    $total_optionvals = $result->PO_RecordCount();	
		$result->Close();		
		
		if ($order >= $total_optionvals || $total_optionvals == 1) {
        pnSessionSetVar('errormsg', _PPC_MOVE_NONEBELOW);
        return false;
    }		

	  if ($tobot != '1') { 	// Move attribute down one position		
			
	      // Move ahead attribute down one position
        $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = $order WHERE $ppc_optionval_column[order] = ($order + 1) AND $ppc_optionval_column[oid] = $oid";
        $dbconn->Execute($sql);
		
        // Move selected attribute up one position
        $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = ($order + 1) WHERE $ppc_optionval_column[vid] = $vid";
        $dbconn->Execute($sql);
				
		} else {
		
	      // Move ahead option value down one position
        $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = ($ppc_optionval_column[order] - 1) WHERE $ppc_optionval_column[order] > '$order' AND $ppc_optionval_column[oid] = '$oid'";
        $dbconn->Execute($sql);
				
        // Move selected option value up one position
        $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = '$total_optionvals' WHERE $ppc_optionval_column[vid] = $vid";		 	
				$dbconn->Execute($sql);		
		
		
		}		
	 
    return true;
}

// Decrease option value position by one or move to top
function paypalcart_adminapi_decoptionval($args) {
    
		// Get arguments
    extract($args);

    // Argument check
    if (!isset($vid) || !is_numeric($vid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		
		// Get the info for this item
   $rows = pnModAPIFunc('PayPalCart', 'admin', 'getoptionval', $vid);
	 extract($rows);			

    // Security check
    if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Order', "::$vid", ACCESS_EDIT) || !pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$oid", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the option value table & column names		
    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];	

    $rows = pnModAPIFunc('PayPalCart', 'admin', 'getoptionval', $vid);		
		extract($rows);
		
		// Get count of total option values in this attribute
    $sql = "SELECT $ppc_optionval_column[vid] FROM $ppc_optionval_table WHERE $ppc_optionval_column[oid] = $oid";
		$result = $dbconn->Execute($sql);
    $total_optionvals = $result->PO_RecordCount();	
		$result->Close();		

		if ($order == 1 || $total_optionvals == 1) {
        pnSessionSetVar('errormsg', _PPC_MOVE_NONEABOVE);
        return false;
    }
		
	  if ($totop != '1') { 	// Move attribute down one position						
	
	      // Move behind option up one position
        $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = $order WHERE $ppc_optionval_column[order] = ($order - 1) AND $ppc_optionval_column[oid] = $oid";
        $dbconn->Execute($sql);
		
        // Move selected option down one position
        $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = ($order - 1) WHERE $ppc_optionval_column[vid] = $vid";
        $dbconn->Execute($sql);
		
		} else {
		
			  // Move behind option up one position
        $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = ($ppc_optionval_column[order] + 1) WHERE $ppc_optionval_column[order] < '$order' AND $ppc_optionval_column[oid] = '$oid'";
        $dbconn->Execute($sql);
		
        // Move selected option down one position
        $sql = "UPDATE $ppc_optionval_table SET $ppc_optionval_column[order] = '1' WHERE $ppc_optionval_column[vid] = $vid";
        $dbconn->Execute($sql);				
		
		}		
 
    return true;
}



// DATA RETREIVAL

// Get information for a product
function paypalcart_adminapi_getproduct($arg) {

    $items = array();

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$arg", ACCESS_READ)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
				return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];

    // Get item information
		$sql = "SELECT * FROM $ppc_items_table WHERE $ppc_items_column[pid] = $arg";
    $result = $dbconn->Execute($sql);

		
    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_GETFAILED);
        return false;
    }

    list($pid, $cid, $prod_name, $sku, $desc, $amount, $option1, $option2,
		     $shipping, $shipping2, $handling, $active, $image_th, $image, $order) = $result->fields;
				 
		$prod_name = str_replace("\'","'",$prod_name);	
		$desc = str_replace("\'","'",$desc);					 
    
		$items = array('pid' => $pid,
						      						'cid' => $cid,
                             'prod_name' => $prod_name,
                             'sku' => $sku,	
                             'desc' => $desc,	
                             'amount' => $amount,	
                             'option1' => $option1,	
                             'option2' => $option2,		
                             'shipping' => $shipping,	
                             'shipping2' => $shipping2,		
                             'handling' => $handling,		
                             'active' => $active,		
                             'image_th' => $image_th,																 														 														 														 														 												 														 														 														 													 
                             'image' => $image,
                             'order' => $order);

    $result->Close();
		
    // Return the items
    return $items;
}


// Get information for products in a specific category
function paypalcart_adminapi_getproductcat($arg) {

    $items = array();

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$arg", ACCESS_READ)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
				return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];

    // Get items
		$sql = "SELECT * FROM $ppc_items_table WHERE $ppc_items_column[cid] = $arg";
    $result = $dbconn->Execute($sql);

		
    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_GETFAILED);
        return false;
    }

    list($pid, $cid, $prod_name, $sku, $desc, $amount, $option1, $option2,
		     $shipping, $shipping2, $handling, $active, $image_th, $image, $order) = $result->fields;
				 
		$prod_name = str_replace("\'","'",$prod_name);
		$desc = str_replace("\'","'",$desc);					 
    
		$items = array('pid' => $pid,
						      						'cid' => $cid,
                             'prod_name' => $prod_name,
                             'sku' => $sku,	
                             'desc' => $desc,	
                             'amount' => $amount,	
                             'option1' => $option1,	
                             'option2' => $option2,		
                             'shipping' => $shipping,	
                             'shipping2' => $shipping2,		
                             'handling' => $handling,		
                             'active' => $active,		
                             'image_th' => $image_th,																 														 														 														 														 												 														 														 														 													 
                             'image' => $image,
                             'order' => $order);

    $result->Close();
		
    // Return the items
    return $items;
}


// Get information for a category
function paypalcart_adminapi_getcategory($arg) {

    $items = array();

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$arg", ACCESS_READ)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
				return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];

    // Get category info
		$sql = "SELECT * FROM $ppc_categories_table WHERE $ppc_categories_column[cid] = $arg";
    $result = $dbconn->Execute($sql);

		
    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_GETFAILED);
        return false;
    }

    list($cid, $cat_name, $desc, $itemcolumns, $active, $image, $order) = $result->fields;
		
		$cat_name = str_replace("\'","'",$cat_name);	
		$desc = str_replace("\'","'",$desc);			
    
		$items = array('cid' => $cid,
                             'cat_name' => $cat_name,
                             'desc' => $desc,	
                             'itemcolumns' => $itemcolumns,															 
                             'active' => $active,		
                             'image' => $image,
                             'order' => $order);

    $result->Close();
		
    // Return the items
    return $items;
}


// Get information for an option
function paypalcart_adminapi_getoption($arg) {

    $items = array();

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$arg", ACCESS_READ)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
				return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_options_table = $pntable['paypalcart_options'];
    $ppc_options_column = &$pntable['paypalcart_options_column'];

    // Get items
		$sql = "SELECT * FROM $ppc_options_table WHERE $ppc_options_column[oid] = $arg";
    $result = $dbconn->Execute($sql);

		
    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_GETFAILED);
        return false;
    }

    list($oid, $opt_name, $label, $desc, $style) = $result->fields;
		
		$opt_name = str_replace("\'","'",$opt_name);	
		$label = str_replace("\'","'",$label);
		$desc = str_replace("\'","'",$desc);			
    
		$items = array('oid' => $oid,
                             'opt_name' => $opt_name,
                             'label' => $label,	
                             'desc' => $desc,															 
                             'style' => $style);

    $result->Close();
		
    // Return the items
    return $items;
}


// Get information for an option value
function paypalcart_adminapi_getoptionval($arg) {

    $items = array();

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$arg", ACCESS_READ)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
				return false;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Get the option value table & column names		
    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];

    // Get items
		$sql = "SELECT * FROM $ppc_optionval_table WHERE $ppc_optionval_column[vid] = $arg";
    $result = $dbconn->Execute($sql);

		
    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_GETFAILED);
        return false;
    }

    list($vid, $oid, $value, $order) = $result->fields;
		
		$value = str_replace("\'","'",$value);
		
    
		$items = array('vid' => $vid,
                             'oid' => $oid,
                             'value' => $value,	
                             'order' => $order);

    $result->Close();
		
    // Return the items
    return $items;
}


function paypalcart_adminapi_imageupload($img) {

    // Argument check
    if (!isset($img)) {
        pnSessionSetVar('statusmsg', _MODARGSERROR);
        return false;
    }	
		
    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Upload:Edit', '::', ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }		

    // What is the max file size that can be upload?
    // In *kilobytes*, i.e. 150 for a 150KB image			
    $maxfilesize = '150';

    $filepath = pnModGetVar('PayPalCart', 'imagepath').'/'.$img['name'];

    // Check if a file was submitted
    if ($img['name'] == '') {
        pnSessionSetVar('statusmsg', _PPC_IMG_NOFILESELECTED);
				return false;
				}
				
    // Check if file is correct filetype
    if ($img['type'] != 'image/pjpeg' && $img['type'] != 'image/jpeg' && $img['type'] != 'image/gif' && $img['type'] != 'image/png') {
        pnSessionSetVar('statusmsg', _PPC_IMG_NOTRIGHTTYPE.' ('.$img['type'].')');
				return false;
				}		
				
    // Check if file is of a reasonable size
    if ($img['size'] > ($maxfilesize*1024)) {
        pnSessionSetVar('statusmsg', _PPC_IMG_FILETOOLARGE.' '.$maxfilesize.'KB');
				return false;
				}								
			          
    @copy($img['tmp_name'], $filepath);
					      
    if (file_exists($filepath)) {
		    return true;
		} else {
		    pnSessionSetVar('statusmsg', 'File selected was not an image or an allowed image type (.JPG or JPEG files only).');
        return false;
		}
		 
}		


function paypalcart_adminapi_imagepurge() {

		
    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart:Upload:Edit', '::', ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _PPC_NOAUTH);
        return false;
    }		

		
    // Fetch all images from store directory
    $handle = opendir(pnModGetVar('PayPalCart', 'imagepath'));
				
		while ($file = readdir($handle)) {
        $filelist[] = $file;
    }
				
		asort($filelist);	
		
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];				
		
		$buttonimage = pnModGetVar('PayPalCart', 'buttonimage');
		$viewcartimage = pnModGetVar('PayPalCart', 'viewcartimage');
		$storelogo = 	pnModGetVar('PayPalCart', 'storelogo');
		
    while (list ($key, $file) = each ($filelist)) {
		
		    $match = 0;
       
				ereg(".gif|.jpg|.png", $file);

        if ($file != '.' && $file != '..' && $file != 'index.html' && $file != 'transparent.png') {
						
				    if ($buttonimage == $file || $viewcartimage == $file || $storelogo == $file)
				        $match = 1;

            // Get category info
		        $sql = "SELECT COUNT(*) FROM $ppc_items_table, $ppc_categories_table WHERE $ppc_items_column[image] = '$file' OR $ppc_items_column[image_th] = '$file' OR $ppc_categories_column[image] = '$file'";
            // echo $sql;
						$result = $dbconn->Execute($sql);		
						list($count) = $result->fields;	
						$result->Close();	
						
						if ($count)
						    $match = 1;				

		        if (!$match) {
						    @exec("rm ".pnModGetVar('PayPalCart', 'imagepath').$file);		
							  $image_count++;
								$images_purged .= $file.', ';
								
						}		
        } 
    } 		
		
    if ($image_count) {
		    $images_purged = substr($images_purged, 0, -2);
		    return array('images' => $images_purged, 'count' => $image_count);
		} else {
		    return false;
		}		
 
}		  

?>
