<?php
// $Id: pnuser.php,v 1.2 2003/07/02 23:32:56 markwest Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Nathan Welch
// Purpose of file:  PayPalCart user display functions
// ----------------------------------------------------------------------

// Set the value below to direct the PayPalCart module to the PayPal
// test website at www.sandbox.paypal.com.  You must have a PayPal
// developer account to access.
$GLOBALS['ppc_debug'] = 0;

// Set form call based on if in debug/testing mode of note
if ($GLOBALS['ppc_debug'] == 1)
   $GLOBALS['ppc_form_call'] = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
else
   $GLOBALS['ppc_form_call'] = 'https://www.paypal.com/cgi-bin/webscr';
	 

	 
$currency_markers = array ('USD' => '$',
                           'EUR' => '&#8364;',
														'GBP' => '&pound;',
														'CAD' => '$',
														'JPY' => '&yen;');	 
	 
$GLOBALS['currency_symbol'] = $currency_markers[pnModGetVar('PayPalCart', 'currency')];	 

// Main PayPalCart display function
// Display main categories/welcome list, if no/invalid cat specified
// Otherwise display thumbnail list of products with add to cart
function paypalcart_user_main() {

    $cid = pnVarCleanFromInput('cid');

    // Create output object
		$output = new pnHTML();
    
    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart::', '::', ACCESS_READ)) {
        $output->Text(_PPC_NOAUTH);
        return $output->GetOutput();
    }
		
    include('header.php');			

    // Add menu to output - it helps if all of the module pages have a standard
    // menu at their head to aid in navigation
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_storefront($cid));
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');			
		
    return $output->GetOutput();
}

function paypalcart_user_popclose() {

$win = pnVarCleanFromInput('win');

if ($win == 'thankyou')
   $redir = pnModURL('PayPalCart','user','thankyou');
else
   $redir = pnModURL('PayPalCart','user','main');

?>



<HTML>
<HEAD><TITLE></TITLE>
<SCRIPT LANGUAGE="JAVASCRIPT">

function closeWin() {

   window.opener.location.href='<?php echo $redir; ?>';
   window.close();
	 
}	 

</SCRIPT></HEAD>
<BODY onload="closeWin();">

</BODY>

</HTML>


<?

exit;

}

// Output main storefront page
function paypalcart_storefront($cid) {

    if (!$cid || !isset($cid))
		    $cid = '0';
				
		$offset = pnVarCleanFromInput('offset');	
		
		if (!isset($offset) || !is_numeric($offset) || $offset < 0 ) {
		    $offset = 0;
		}
		
		$offset = intval($offset);					

    OpenTable();
		
    paypalcart_user_storeheader();

		// Get a list of items in this category, and generate an item edit table
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    // Get the category table & column names
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];		
		
        $sql = "SELECT $ppc_categories_column[name], $ppc_categories_column[itemcolumns] FROM $ppc_categories_table WHERE $ppc_categories_column[cid] = '$cid' AND $ppc_categories_column[active] = '1'";
 		    $result = $dbconn->Execute($sql);
		
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
		
		    if (!$result->PO_RecordCount()) { // No category selected or does not exist, so output main store page	
				
		    ?>
		
		     <BR>
		     <SPAN CLASS="pn-normal"><?php echo nl2br(trim(pnModGetVar('PayPalCart', 'storeintro'))); ?></SPAN>
		
		<?php	
		         // Get the category info
						 $sql = "SELECT $ppc_categories_column[cid], $ppc_categories_column[name], $ppc_categories_column[desc], $ppc_categories_column[image]
						         FROM $ppc_categories_table WHERE $ppc_categories_column[active] = '1' ORDER BY $ppc_categories_column[order]";
 		         $result = $dbconn->Execute($sql);
		
             if ($dbconn->ErrorNo() != 0) {
                 return false;
             }
						 
						 $num_cols = pnModGetVar('PayPalCart', 'categorycolumns');
						 
						 $count = 0;
						 $cat_flag = 0;						 
						 
						 // Output the main category list
						 for (; !$result->EOF; $result->MoveNext()) {
					   
								 list($cid, $cat_name, $desc, $image) = $result->fields;
								 
								 // Permission check for this category...
		              if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_READ)) {
                      continue;
                 }
								 
								     $cat_name = str_replace("\'","'",$cat_name);	
								     $desc = str_replace("\'","'",$desc);											 
								 
						         if (!$cat_flag) {
								         echo '<BR><TABLE WIDTH="100%" BORDER="0" CELLPADDING="8" CELLSPACING="0"><TR VALIGN="TOP" ALIGN="LEFT">';
								         $cat_flag = 1;		 
								     }
								 
                     if ($count == $num_cols) {
                        echo '<TR VALIGN="TOP" ALIGN="LEFT">';
                        $count = 0;
                     }		
								 
								 echo '<TD><TABLE BORDER="0" CELLPADDING="5"><TR VALIGN="TOP" ALIGN="LEFT">';
								 $cat_image = pnModGetVar('PayPalCart', 'imagepath').$image;
								 
								 if (file_exists($cat_image) && $image) {
								 
								     echo '<TD><A HREF="'.pnModURL('PayPalCart','user','main', array('cid' => $cid)).'">';
										 echo '<IMG SRC="'.$cat_image.'" BORDER="0" ALT="'.$cat_name.'"></A></TD>';
								 
								 }
								 
								 ?>
								 
								 <TD>
								 <SPAN CLASS="pn-title">
								 <A HREF="<?php echo pnModURL('PayPalCart','user','main', array('cid' => $cid)); ?>" CLASS="pn-title"><?php echo $cat_name; ?></A>
								 
								 <?php
								 
								 $sql = "SELECT $ppc_items_column[pid] FROM $ppc_items_table WHERE $ppc_items_column[cid] = '$cid' AND $ppc_items_column[active] = '1'";
								 $result2 = $dbconn->Execute($sql);
								 
		             $numitems = 0;
								 
								 // Loop through records to count items user has permission to see
		             for (; !$result2->EOF; $result2->MoveNext()) {
		
		                 list($pid) = $result2->fields;
				
				             if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_READ)) {
                         $numitems++;
                     }		
		
		             }			
				
				         echo '&nbsp;&nbsp;('.$numitems.')';
				
				         ?>
								 
								 
								 </SPAN>
								 <SPAN CLASS="pn-normal">
								 
								 <?php
								 
								 if ($desc)
								     echo '<BR>'.nl2br(trim($desc));
								 
								 ?>
								 </SPAN><BR><BR><SPAN CLASS="pn-sub">[&nbsp;<A HREF="<?php echo pnModURL('PayPalCart','user','main', array('cid' => $cid)); ?>" CLASS="pn-normal"><?php echo _PPC_VIEWTHISCATEGORY; ?></A>&nbsp;]
								 
								 <?php
								 // Show Edit link if authorized
                 if (pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT)) {
                    echo '&nbsp;&nbsp;[&nbsp;<a href="'. pnModURL('PayPalCart','admin','editcategorymenu', array('cid' => $cid)) .'" CLASS="pn-normal">'._PPC_EDIT.'</a>&nbsp;]';
                 }
								 ?>
								 
								 
								 </SPAN>
								 </TD></TR></TABLE></TD>
								 
								 <?php	
								 
								 $count++;									 
								 
                 if ($count == $num_cols) {
                    echo '</TR>';
                 }										 						 
						 
						 }
						 
						 if ($cat_flag) {

                 // Close off table columns if items ouput
								 if ($count == $num_cols) {
                     echo '</table>';
                 } else {
								     echo '<td colspan="'.($num_cols-$count).'">&nbsp;</td>';
                     echo '</tr></table>';
                 }

             } else {
						 
						 ?>
						 						 
						 <BR><BR><DIV ALIGN="CENTER"><SPAN CLASS="pn-normal"><?php echo _PPC_NOCATEGORIES; ?></SPAN></DIV><BR><BR><BR>				 
						 
						 <?php		
						 				 
						 }
						 
						 
		
		    } else { // Category exists - fetch items and display, thumbnail (if exists), item name, price, buy now button, and link to full item page
				 
				     
             // Check if user has permissions to access this category;
						if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_READ)) {
						 
						     ?>
								 
						     <br><div align="left"><span class="pn-sub"><A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-sub"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a></span></div><br>
						 						 
						     <BR><BR><DIV="CENTER"><SPAN CLASS="pn-normal"><?php echo _PPC_CATEGORYNOTAUTH; ?></SPAN></DIV><BR><BR><BR>					 
						 
						     <?php		
						 				 
						 }	else {				 
						 
						     // Get category name & output links
						     list($cat_name, $num_cols) = $result->fields;
						 
						     ?>
						 
						     <br><div align="left"><span class="pn-sub"><A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-sub"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a> &gt;&gt; <?php echo $cat_name ?></span></div><br>
						 
						     <?php
				 
                 // Get the item table & column names		
                 $ppc_items_table = $pntable['paypalcart_items'];
                 $ppc_items_column = &$pntable['paypalcart_items_column'];
						 
		             // Get the item info
						     $sql = "SELECT $ppc_items_column[pid], $ppc_items_column[cid] FROM $ppc_items_table WHERE $ppc_items_column[cid] = '$cid' AND $ppc_items_column[active] = '1' ORDER BY $ppc_items_column[order]";
 		         
		             $result = $dbconn->Execute($sql);
                 // Get Count of browsed matches (for page spanning, etc...)			
		             $records = $result->RecordCount();
						 
		             $records = 0;
								 
						     // Loop through records to count items user has permission to see
		             for (; !$result->EOF; $result->MoveNext()) {
		
		                 list($pid, $cid) = $result->fields;
				
				             if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_READ)) {
                             $records++;
                     }		
		
		             }								 
						 
                 $result->Close();				
	
		             $result = $dbconn->Execute($sql."  LIMIT $offset, ".pnModGetVar('PayPalCart', 'itemsperpage'));		
		
		             $span_links = paypalcart_user_spanlinks(array('total' => $records,'offset' => $offset, 'cid' => $cid));
		
		             if ($span_links)
		                 echo '<DIV ALIGN="RIGHT"><SPAN CLASS="pn-sub"><B>'.$span_links[0].'</B><NOBR>&nbsp;&nbsp;&nbsp;&nbsp;'.$span_links[1].'</NOBR></SPAN></DIV><BR>';
		
                 if ($dbconn->ErrorNo() != 0) {
                     return false;
                 }
						 		 
						     $count = 0;
						     $item_flag = 0;
						 
						     // Output the items
						     for (; !$result->EOF; $result->MoveNext()) {
					 
						         list($pid, $cid) = $result->fields;
								 
								     if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_READ) && pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_READ)) {
								     
						             if (!$item_flag) {
								             echo '<BR><TABLE WIDTH="100%" BORDER="0"><TR VALIGN="TOP" ALIGN="CENTER">';
								             $item_flag = 1;		 
								         }
								  
                         if ($count == $num_cols) {
                            echo '<TR VALIGN="TOP" ALIGN="CENTER">';
                            $count = 0;
                         }												 
										 
										     echo '<TD>';
								         paypalcart_itemdisplay(array('pid' => $pid, 'offset' => $offset, 'brief' => '1'));
								         echo '</TD>';	
                         $count++;
									    }								 									 
								 
                     if ($count == $num_cols) {
                        echo '</TR>';
                     }									 																															
								 
						     }
						 
						     if ($item_flag) {

                     // Close off table columns if items ouput
							    	 if ($count == $num_cols) {
                         echo '</table>';
                     } else {
							    	     echo '<td colspan="'.($num_cols-$count).'">&nbsp;</td>';
                         echo '</tr></table>';
                     }
								 
		                 if ($span_links)
		                    echo '<BR><DIV ALIGN="RIGHT"><SPAN CLASS="pn-sub"><B>'.$span_links[0].'</B><NOBR>&nbsp;&nbsp;&nbsp;&nbsp;'.$span_links[1].'</NOBR></SPAN></DIV><BR>';

								 

                 } else {
						 
						     ?>
						 						 
						     <BR><BR><DIV="CENTER"><SPAN CLASS="pn-normal"><?php echo _PPC_NOITEMS; ?></SPAN></DIV><BR>					 
						 
						 <?php		
						 				 
						     }
								 
						} // End if category permission check (else)		 
				 
				}
				
		echo '<BR><BR>'.paypalcart_user_categoryselectlist($cid);						

    CloseTable();
		
		$result->Close();

}


// Product detail page load
function paypalcart_user_detail() {

    $pid = pnVarCleanFromInput('pid');
    $offset = pnVarCleanFromInput('offset');		

    // Create output object
		$output = new pnHTML();
		
		if (!pnModAPILoad('PayPalCart', 'user')){
		    return paypalcart_user_error(_ERROR_LOAD);
		}	

    // Get item variables
	  $item = pnModAPIFunc('PayPalCart', 'user', 'getproduct', $pid);
	  extract($item);		
    
    include('header.php');			

    // Add menu to output - it helps if all of the module pages have a standard
    // menu at their head to aid in navigation
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_itemdetail(array('pid' => $pid, 'offset' => $offset)));
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');			
		
    return $output->GetOutput();
}


// Output for product detail page
function paypalcart_itemdetail($vars) {

    extract($vars);
		
    if (!$pid || !isset($pid))
		    $pid = '0';

    OpenTable();
		
    paypalcart_user_storeheader();	

		// Get a list of items in this category, and generate an item edit table
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];		
    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];
		
        $sql = "SELECT $ppc_items_column[pid], $ppc_items_column[name], $ppc_categories_column[cid], $ppc_categories_column[name] FROM $ppc_items_table, $ppc_categories_table WHERE $ppc_items_column[pid] = '$pid' AND $ppc_items_column[active] = '1' AND $ppc_categories_column[active] = '1' AND $ppc_items_column[cid] = $ppc_categories_column[cid]";
 		    $result = $dbconn->Execute($sql);
		
        if ($dbconn->ErrorNo() != 0) {
            return false;
        }
		
		    if (!$result->PO_RecordCount()) { // No item selected or does not exist, so output main store page	

						 ?>
						 						 
						 <BR><BR><DIV ALIGN="CENTER"><SPAN CLASS="pn-normal"><?php echo _PPC_NOITEMFOUND; ?> :: <A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-normal"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a></SPAN></DIV><BR><BR>					 
						 
						 <?php						
				
				
				} else { // Output top menu and fetch item detail
				
				
				     // Check if user has permission to see product...
		         if (!pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_READ) || !pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_READ)) {
						     ?>
						 
						     <br><div align="left"><span class="pn-sub"><A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-sub"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a></span></div>
								 
						     <BR><BR><DIV="CENTER"><SPAN CLASS="pn-normal"><?php echo _PPC_NOAUTH; ?></SPAN></DIV><BR><BR><BR>											 
				 
						     <?php
								 
             } else {
	
				         // Get category name & output links
						     list($pid, $prod_name, $cid, $cat_name) = $result->fields;
						 
						     ?>
						 
						     <br><div align="left"><span class="pn-sub"><A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-sub"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a> &gt;&gt; <A HREF="<?php echo pnModURL('PayPalCart','user','main', array('cid' => $cid, 'offset' => $offset)); ?>" CLASS="pn-sub"><?php echo $cat_name; ?></A> &gt;&gt; <?php echo $prod_name; ?></span></div>
				 
						     <?php
						 
						    paypalcart_itemdisplay(array('pid' => $pid, 'offset' => $offset, 'brief' => '0'));		
					   
						 }
				}
				
		echo paypalcart_user_categoryselectlist($cid);						
						 
    CloseTable();
		
		$result->Close();

}


// Item display function, for category product pages and
// product detail pages 
function paypalcart_itemdisplay($vars) {

    extract($vars);
		
		if (!pnModAPILoad('PayPalCart', 'user')){
		    return paypalcart_user_error(_ERROR_LOAD);
		}	

    // Get item variables
	  $item = pnModAPIFunc('PayPalCart', 'user', 'getproduct', $pid);
	  extract($item);
	 
	  // Get configuration variables
	  $paypal_email = pnModGetVar('PayPalCart', 'paypal_email');
	  $store_email = pnModGetVar('PayPalCart', 'store_email');
	  $currency = pnModGetVar('PayPalCart', 'currency');
	  $handling_cart = pnModGetVar('PayPalCart', 'handling_cart');
	  $note = pnModGetVar('PayPalCart', 'note');
	  $notemsg = pnModGetVar('PayPalCart', 'notemsg');
	  $shippingaddr = pnModGetVar('PayPalCart', 'shippingaddr');
	  $page_style = pnModGetVar('PayPalCart', 'page_style');
	  $image_url = pnModGetVar('PayPalCart', 'image_url');
	  $bgcolor = pnModGetVar('PayPalCart', 'bgcolor');	


    if (pnModGetVar('PayPalCart', 'nojscript')) {
		    $paypal_form = '<form method="post" action="'.$GLOBALS['ppc_form_call'].'">';
  	    $paypal_form .=	'<input type="hidden" name="cancel_return" value="'.pnModURL('PayPalCart','user','main').'">';			
  	    $paypal_form .=	'<input type="hidden" name="return" value="'.pnModURL('PayPalCart','user','thankyou').'">';					    
		} else {
		    $paypal_form = '<form method="post" action="'.$GLOBALS['ppc_form_call'].'" target="paypal" onsubmit="window.open (\'\',\'paypal\',\'height='.pnModGetVar('PayPalCart', 'cartwindowheight').', width='.pnModGetVar('PayPalCart', 'cartwindowwidth').', toolbar=no, menubar=no, scrollbars=yes, status=yes, resizable=no\')">';
  	    $paypal_form .=	'<input type="hidden" name="cancel_return" value="'.pnModURL('PayPalCart','user','popclose').'">';			
  	    $paypal_form .=	'<input type="hidden" name="return" value="'.pnModURL('PayPalCart','user','popclose', array('win' => 'thankyou')).'">';					
		}
		
		$paypal_form .=	'<input type="hidden" name="cmd" value="_cart">';
  	$paypal_form .=	'<input type="hidden" name="business" value="'.$paypal_email.'">';	
    
		if ($amount)
		    $paypal_form .=	'<input type="hidden" name="amount" value="'.$amount.'">';

		if ($prod_name)
		    $paypal_form .=	'<input type="hidden" name="item_name" value="'.$prod_name.'">';

		if ($sku)   
		    $paypal_form .=	'<input type="hidden" name="item_number" value="'.$sku.'">';
				
		if ($note) {
        $paypal_form .=	'<input type="hidden" name="no_note" value="0">';	
        $paypal_form .=	'<input type="hidden" name="cn" value="'.$notemsg.'">';			
		}	else {
        $paypal_form .=	'<input type="hidden" name="no_note" value="1">';			
		}	
				
    if ($bgcolor) 
				$paypal_form .=	'<input type="hidden" name="cs" value="1">';
							
				
    if ($image_url)				
        $paypal_form .=	'<input type="hidden" name="image_url" value="'.$image_url.'">';
						
				
		if ($shippingaddr)
		    $paypal_form .=	'<input type="hidden" name="no_shipping" value="0">';
    else
		    $paypal_form .=	'<input type="hidden" name="no_shipping" value="1">';
								
		if ($page_style)		
        $paypal_form .=	'<input type="hidden" name="page_style" value="'.$page_style.'">';	
				
    $paypal_form .=	'<input type="hidden" name="currency_code" value="'.$currency.'">';		
		
		if ($handling)	
        $paypal_form .=	'<input type="hidden" name="handling" value="'.$handling.'">';
				
		if ($handling_cart)	
        $paypal_form .=	'<input type="hidden" name="handling_cart" value="'.$handling_cart.'">';
				
		if ($shipping)	
        $paypal_form .=	'<input type="hidden" name="shipping" value="'.$shipping.'">';
				
		if ($shipping2)			
        $paypal_form .=	'<input type="hidden" name="shipping2" value="'.$shipping2.'">';
			
    $paypal_form .=	'<input type="hidden" name="add" value="1">';	
		
		// Form Button
		$paypal_button =	'<input type="image" src="'.pnModGetVar('PayPalCart', 'imagepath') . pnModGetVar('PayPalCart', 'buttonimage').'" style="border: none;" name="submit" alt="'._PPC_ADD." ".$prod_name." "._PPC_TOCART.'">';

    if ($brief) { // Show the brief product display (thumbnail, name, price, button)
		
        if (pnModGetVar('PayPalCart', 'buttondetailonly') == '0' || pnModGetVar('PayPalCart', 'buttondetailonly') == '2' && !$option1 && !$option2)
				    echo $paypal_form;
		
		    ?>
				
			  <DIV ALIGN="CENTER">
				
				<?php
				
				$item_image_th = pnModGetVar('PayPalCart', 'imagepath').$image_th;
								 
				if (file_exists($item_image_th) && $image_th) {
								 
				    echo '<A HREF="'.pnModURL('PayPalCart','user','detail', array('pid' => $pid, 'offset' => $offset)).'">';
				    echo '<IMG SRC="'.$item_image_th.'" BORDER="0" ALT="'.$prod_name.'"></A>';
								 
				}
				
				if ($option1 || $option2)
				    $details = _PPC_PRODOPTDETAILS;
				else 
				    $details = _PPC_PRODDETAILS;				
				
				?>
				
				<BR>
				
			  <SPAN CLASS="pn-normal"><B><?php echo $prod_name; ?></B></SPAN>
				<BR><SPAN CLASS="pn-sub">[ <A HREF="<?php echo pnModURL('PayPalCart','user','detail', array('pid' => $pid, 'offset' => $offset)); ?>" CLASS="pn-sub"><?php echo $details; ?></A> ]</SPAN>
				
				<BR><SPAN CLASS="pn-title"><?php echo $GLOBALS['currency_symbol'].$amount; ?></SPAN>
				
				<?php
				
				// Show Edit link if authorized
        if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_EDIT) && pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT)) {
            echo '&nbsp;&nbsp;<SPAN CLASS="pn-sub">[&nbsp;<a href="'. pnModURL('PayPalCart','admin','edititemmenu', array('pid' => $pid)) .'" CLASS="pn-sub">'._PPC_EDIT.'</a>&nbsp;]</SPAN>';
        }
				
				?>				
				
				<BR><BR>
				
				<?php 
				
        list($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();				
				$ppc_options_table = $pntable['paypalcart_options'];
        $ppc_options_column = &$pntable['paypalcart_options_column'];
        $ppc_optionval_table = $pntable['paypalcart_option_values'];
        $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];		
				
				$optionmatch = 0;
				
				// Check permissions for first option
				if ($option1 && pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$option1", ACCESS_READ)) {				

				    $sql = "SELECT $ppc_optionval_column[vid], $ppc_optionval_column[value], $ppc_options_column[label] FROM $ppc_optionval_table, $ppc_options_table WHERE $ppc_optionval_column[oid] = '$option1' AND $ppc_options_column[oid] = $ppc_optionval_column[oid] ORDER BY $ppc_optionval_column[order]";
				    $result = $dbconn->Execute($sql);	
				
				    for (; !$result->EOF; $result->MoveNext()) {
        
				       list($vid, $value, $label) = $result->fields;
							 
							 // Include as "default" option, the first option in the list user has permission for
							 if (pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$vid", ACCESS_READ)) {
							     $optionmatch = 1;
									 break;
							 }		 
								
  			    }
						
				    if ($optionmatch) {
				        echo '<INPUT TYPE="HIDDEN" NAME="on0" VALUE="'.$label.'">';
				        echo '<INPUT TYPE="HIDDEN" NAME="os0" VALUE="'.$value.'">';						
				    }							
				}				
				
				$optionmatch = 0;
				
				// Check permissions for second option
				if ($option2 && pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$option2", ACCESS_READ)) {				

				    $sql = "SELECT $ppc_optionval_column[vid], $ppc_optionval_column[value], $ppc_options_column[label] FROM $ppc_optionval_table, $ppc_options_table WHERE $ppc_optionval_column[oid] = '$option2' AND $ppc_options_column[oid] = $ppc_optionval_column[oid] ORDER BY $ppc_optionval_column[order]";
				    $result = $dbconn->Execute($sql);	
				
				    for (; !$result->EOF; $result->MoveNext()) {
        
				       list($vid2, $value2, $label2) = $result->fields;
							 
							 // Include as "default" option, the first option in the list user has permission for
							 if (pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$vid2", ACCESS_READ)) {
							     $optionmatch = 1;
									 break;
							 }		 
								
  			    }
						
				    if ($optionmatch) {
				        echo '<INPUT TYPE="HIDDEN" NAME="on1" VALUE="'.$label2.'">';
				        echo '<INPUT TYPE="HIDDEN" NAME="os1" VALUE="'.$value2.'">';						
				    }							
				}
				
				if (pnModGetVar('PayPalCart', 'buttondetailonly') == '0' || pnModGetVar('PayPalCart', 'buttondetailonly') == '2' && !$option1 && !$option2)  echo $paypal_button; ?>
				     </DIV>
		         </FORM><BR>
			  <?php	

		} else { // Show the detailed product display (large pic, name, description price, options, button)
		
		    echo $paypal_form;	
		
		?>
		    <BR>
						    	
		    <TABLE BORDER="0" CELLPADDING="8"><TR VALIGN="TOP" ALIGN="LEFT">
		    <TD>
		
				<?php
				
				// Look for full-size image - if it doesn't exist, try the thumbnail
				$item_image_th = pnModGetVar('PayPalCart', 'imagepath').$image_th;
				$item_image = pnModGetVar('PayPalCart', 'imagepath').$image;				
								 
				if (file_exists($item_image) && $image) {
								 
				    echo '<IMG SRC="'.$item_image.'" BORDER="0" ALT="'.$prod_name.'">';
								 
				} elseif (file_exists($item_image_th) && $image_th) {
								 
				    echo '<IMG SRC="'.$item_image_th.'" BORDER="0" ALT="'.$prod_name.'">';
								 
				} 
				
				?>		
		
		    </TD>
		
		    <TD>
				<div align="left">
				
				<SPAN CLASS="pn-logo"><?php echo $prod_name; ?></B></SPAN>
				
				<?php
				  
					// Show Edit link if authorized
          if (pnSecAuthAction(0, 'PayPalCart:Product:Edit', "::$pid", ACCESS_EDIT) && pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_EDIT)) {
              echo '&nbsp;&nbsp;&nbsp;&nbsp;<SPAN CLASS="pn-normal">[&nbsp;<a href="'. pnModURL('PayPalCart','admin','edititemmenu', array('pid' => $pid)) .'" CLASS="pn-normal">'._PPC_EDIT.'</a>&nbsp;]</SPAN>';
          }
				
				  if ($sku)
					   echo '<BR><SPAN CLASS="pn-normal">('._PPC_ITEM.'# '.$sku.')</SPAN>';
				
				?>
				
				
				
				<BR><BR><SPAN CLASS="pn-normal"><?php echo nl2br(trim($desc)); ?></SPAN><BR><BR>
				
				<?php
				
				if ($option1 && pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$option1", ACCESS_READ))
				    echo paypalcart_user_optionselectlist($option1,0);
				
				?>				
				
				<BR>			
				
				<?php
				
				if ($option2 && pnSecAuthAction(0, 'PayPalCart:Option:Edit', "::$option2", ACCESS_READ))
				    echo paypalcart_user_optionselectlist($option2,1);
				
				?>		
								
				<BR>
				<TABLE BORDER="0">
				<TR VALIGN="MIDDLE"><TD><SPAN CLASS="pn-logo"><?php echo $GLOBALS['currency_symbol'].$amount; ?></SPAN></TD>
				<TD>&nbsp;&nbsp;&nbsp;</TD>
				<TD><?php echo $paypal_button;?></TD>
				
				</TR>
				</TABLE>
				</div>	
		    </TD>
		    </TR></TABLE>
	      </FORM>
		<?php
			
			
		} 
		
	
    return;	
		
}

// Store Information page load
function paypalcart_user_storeinfo() {

    // Create output object
		$output = new pnHTML();
    
    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart::', '::', ACCESS_READ)) {
        $output->Text(_PPC_NOAUTH);
        return $output->GetOutput();
    }
		
    include('header.php');			

    // Add menu to output - it helps if all of the module pages have a standard
    // menu at their head to aid in navigation
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_storeinfo());
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');			
		
    return $output->GetOutput();
}

// Output for store information page
function paypalcart_storeinfo() {
 
    OpenTable();
		
		paypalcart_user_storeheader();
		
		?>
		
		<br><div align="left"><span class="pn-sub"><A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-sub"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a> &gt;&gt; <?php echo _PPC_STOREINFO ?></span></div><br>
		
		<DIV ALIGN="LEFT" CLASS="pn-normal">
		
		<?php echo nl2br(trim(pnModGetVar('PayPalCart', 'storeinfo'))); ?>
		
		</DIV>
		
		
		<BR>
		<DIV ALIGN="CENTER"><SPAN CLASS="pn-normal">[ <A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-normal"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a> ]</SPAN></DIV>
		
		<?
		
		
		CloseTable();			 
			

    return;

}

// Thank You page load
function paypalcart_user_thankyou() {

    // Create output object
		$output = new pnHTML();
    
    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart::', '::', ACCESS_READ)) {
        $output->Text(_PPC_NOAUTH);
        return $output->GetOutput();
    }
		
    include('header.php');			

    // Add menu to output - it helps if all of the module pages have a standard
    // menu at their head to aid in navigation
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(paypalcart_thankyou());
    $output->SetInputMode(_PNH_PARSEINPUT);

    include('footer.php');			
		
    return $output->GetOutput();
}


// Output for Thank You page
function paypalcart_thankyou() {
 
   OpenTable();
		
		paypalcart_user_storeheader();
		
		?>
		
		<br><div align="left"><span class="pn-sub"><A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-sub"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a> &gt;&gt; <?php echo _PPC_ORDERRECEIVED ?></span></div><br>

		<DIV ALIGN="CENTER"><SPAN CLASS="pn-logo"><?php echo pnModGetVar('PayPalCart', 'thankstitle'); ?></SPAN></DIV><BR>
		
		<DIV ALIGN="LEFT" CLASS="pn-normal">
		
		<?php echo nl2br(trim(pnModGetVar('PayPalCart', 'thankstext'))); ?>
		
		</DIV>
		
		
		<BR>
		<DIV ALIGN="CENTER"><SPAN CLASS="pn-normal">[ <A HREF="<?php echo pnModURL('PayPalCart','user','main'); ?>" CLASS="pn-normal"><?php echo pnModGetVar('PayPalCart', 'storename'); ?> <?php echo _PPC_HOME ?></a> ]</SPAN></DIV>
		
		<?
		
					 
		CloseTable();	

    return;

}



// Create a select list of available categories
function paypalcart_user_categoryselectlist($selected = '') {

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];
		
	  $output = '<CENTER><TABLE BORDER="0" WIDTH="100%"><TR VALIGN="MIDDLE" ALIGN="CENTER">';
		$output .= '<TD>'.paypalcart_user_viewcartbutton().'</TD>';
		
	  $output .= '<TD><FORM ACTION="'.pnModURL('PayPalCart','user','main').'" METHOD="POST" STYLE="margin: 0px;"><SPAN CLASS="pn-normal"><B>'. _PPC_JUMPCAT .':</B></SPAN>&nbsp;<SELECT NAME="cid" CLASS="pn-normal">';
		
    $sql = "SELECT $ppc_categories_column[cid], $ppc_categories_column[name] FROM $ppc_categories_table WHERE $ppc_categories_column[active] = '1' ORDER BY $ppc_categories_column[order]";
 		
		$result = $dbconn->Execute($sql);
		
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
		
    for (; !$result->EOF; $result->MoveNext()) {
        
				list($cid, $cat_name) = $result->fields;
				
				// Check permission to access that category
				if (!pnSecAuthAction(0, 'PayPalCart:Category:Edit', "::$cid", ACCESS_READ))
				    continue;
				
        $output .= '<OPTION VALUE="'.$cid.'"';
	
        if ($cid == $selected)
            $output .= ' SELECTED="SELECTED"';			
			
		    $output .= '>'.$cat_name.'</OPTION>';			
				
    }							

    $result->Close();		
    
	  $output .= '</SELECT>&nbsp;&nbsp;<INPUT TYPE="SUBMIT" VALUE="'._PPC_GO.'"></FORM></TD>';
	  $output .= '</TR></TABLE></CENTER><BR><BR>';	
		return $output;
}

// Create a select list of options
function paypalcart_user_optionselectlist($oid, $optionvalue) {

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
    // Get the option table & column names		
    $ppc_options_table = $pntable['paypalcart_options'];
    $ppc_options_column = &$pntable['paypalcart_options_column'];
    $ppc_optionval_table = $pntable['paypalcart_option_values'];
    $ppc_optionval_column = &$pntable['paypalcart_option_values_column'];	
		
    $sql = "SELECT $ppc_options_column[label], $ppc_options_column[style], $ppc_options_column[desc] FROM $ppc_options_table WHERE $ppc_options_column[oid] = '$oid'";
		$result = $dbconn->Execute($sql);

    if ($dbconn->ErrorNo() != 0) {
        return false;
    }		
		
		list($label, $style, $desc) = $result->fields;
		
		$label = str_replace("\'","'",$label);	
		$desc = str_replace("\'","'",$desc);					

		if ($style == '2') { // Style is a text field
		
		    $output = '<TABLE BORDER="0" CELLSPACING="4" CELLPADDING="0"><TR ALIGN="LEFT" VALIGN="MIDDLE"><TD>';
		    $output .= '<SPAN CLASS="pn-normal"><B>'.$label.':</B></SPAN>&nbsp;';
		    $output .= '<input type="hidden" name="on'.$optionvalue.'" value="'.$label.'">';
		    $output .= '<input type="text" name="os'.$optionvalue.'" value="" SIZE="15" CLASS="pn-normal">';
		    $output .= '</TD><TD><SPAN CLASS="pn-sub">'.$desc.'</SPAN></TD></TR></TABLE>';
				return $output;										
		}			
		
    $sql = "SELECT $ppc_optionval_column[vid], $ppc_optionval_column[value] FROM $ppc_optionval_table WHERE $ppc_optionval_column[oid] = '$oid' ORDER BY $ppc_optionval_column[order]";
		$result = $dbconn->Execute($sql);
		
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
		
    for (; !$result->EOF; $result->MoveNext()) {
        
				list($vid, $value) = $result->fields;
				
				// Check permission to access that category
				if (!pnSecAuthAction(0, 'PayPalCart:OptionValue:Edit', "::$vid", ACCESS_READ))
				    continue;
				
				if (!$count)
						$output .= '<TABLE BORDER="0" CELLSPACING="4" CELLPADDING="0"><TR ALIGN="LEFT" VALIGN="MIDDLE"><TD><SPAN CLASS="pn-normal"><B>'.$label.':</B></SPAN>&nbsp;<input type="hidden" name="on'.$optionvalue.'" value="'.$label.'">';
				
				if (!$count && !$style)		
						$output .= '<SELECT name="os'.$optionvalue.'" CLASS="pn-normal">';

				if (!$count)
					 $optioncheck = 'CHECKED="CHECKED"';	
				else
				   $optioncheck = '';
				
				if (!$style)				
	          $output .= '<OPTION VALUE="'.$value.'">'.$value.'</OPTION>';
				else 
	          $output .= '<SPAN CLASS="pn-normal"><NOBR><INPUT TYPE="RADIO" name="os'.$optionvalue.'" VALUE="'.$value.'" '.$optioncheck.'>'.$value.'</NOBR></SPAN>&nbsp;&nbsp; ';					
    		$count ++;
				
				}							


    $result->Close();
		
		if ($count && !$style)
		    $output .= '</SELECT>';		
		
		if ($count)
		    $output .= '</TD><TD><SPAN CLASS="pn-sub">'.$desc.'</SPAN></TD></TR></TABLE>';		
    
		return $output;
}


// Output page numbers and spanning links
function paypalcart_user_spanlinks($pageinfo) {

    extract($pageinfo);
		
		$spannum = pnModGetVar('PayPalCart', 'itemsperpage');
		
		// Don't output span links if none
		if ($total <= 0)
		    return false;
				
		$span_links['0'] = _PPC_PAGE.': ';		
				
		for($i = 0; $i < $total; $i+= $spannum) {
		
		$pagecount++;
		
		$this_offset = $i;
		
		$j = $i + $spannum;
		
		if ($j > $total)
		    $j = $total;
		
		// Previous Page Link
		if ($i == 0 && $offset != 0)		
		    $span_links[0] .= '<A HREF="'.pnModUrl('PayPalCart', 'user', 'main', array('offset' => ($offset - $spannum), 'cid' => $cid)).'" CLASS="pn-sub" STYLE="text-decoration:none;">&lt;&lt;</A>&nbsp;&nbsp;';				

		// Next Page Link
		if ($i != $offset && $i == ($offset + $spannum))		
		    $next_link = '&nbsp;<A HREF="'.pnModUrl('PayPalCart', 'user', 'main', array('offset' => $this_offset, 'cid' => $cid)).'" CLASS="pn-sub" STYLE="text-decoration:none;">&gt;&gt;</A>';				
				
				
		if ($i != $offset)
		    $span_links[0] .= '<A HREF="'.pnModUrl('PayPalCart', 'user', 'main', array('offset' => $i, 'cid' => $cid)).'" CLASS="pn-sub">';
		else {
		           
				if (($i+1) == $j)
				    $span_links[1]= _PPC_VIEWINGITEMS.' '.$j.' '._PPC_OF.' '.$total;	
				else
				    $span_links[1]= _PPC_VIEWINGITEMS.'s '.($i+1).'-'.$j.' '._PPC_OF.' '.$total;										
		    }
		
		    $span_links[0] .= $pagecount;
		
		if ($i != $offset)
		    $span_links[0] .= '</A>';
				
		$span_links[0] .= '&nbsp;';		

		}
		
		$span_links[0] .= $next_link;
	
		return $span_links;
}


// Output the "View Cart" form/button
function paypalcart_user_viewcartbutton() {

		$paypal_button =	'<input type="image" src="'.pnModGetVar('PayPalCart', 'imagepath') . pnModGetVar('PayPalCart', 'viewcartimage').'" style="border: none;" name="submit" alt="'._PPC_VIEWCART.'">';


    if (pnModGetVar('PayPalCart', 'nojscript'))
		    $output = '<form method="post" action="'.$GLOBALS['ppc_form_call'].'">';    
		else
		    $output = '<form method="post" action="'.$GLOBALS['ppc_form_call'].'" target="paypal" onsubmit="window.open (\'\',\'paypal\',\'height='.pnModGetVar('PayPalCart', 'cartwindowheight').', width='.pnModGetVar('PayPalCart', 'cartwindowwidth').', toolbar=no, menubar=no, scrollbars=yes, status=yes, resizable=no\')">';

		$output .= '<input type="hidden" name="cmd" value="_cart">';
    $output .= '<input type="hidden" name="business" value="'.pnModGetVar('PayPalCart', 'paypal_email').'">';
    $output .= $paypal_button;
    $output .= '<input type="hidden" name="display" value="1">';
    $output .= '</form>';		

    return $output;
		
}


// Output the store header
function paypalcart_user_storeheader() {

		echo '<DIV ALIGN="CENTER">';
		
		$store_logo_image = pnModGetVar('PayPalCart', 'imagepath').pnModGetVar('PayPalCart', 'storelogo');
		
    if (file_exists($store_logo_image) && pnModGetVar('PayPalCart', 'storelogo')) {
								 
				    echo '<IMG SRC="'.$store_logo_image.'" BORDER="0" ALT="'.pnModGetVar('PayPalCart', 'storename').'">';
								 
		} else {		

		    echo '<SPAN CLASS="pn-logo">'.pnModGetVar('PayPalCart', 'storename').'</SPAN>';
		
		}

		echo '<BR><BR><SPAN CLASS="pn-sub">[ <A HREF="'.pnModURL('PayPalCart','user','storeinfo').'" CLASS="pn-sub">'._PPC_STOREINFO.'</A> ]</SPAN></DIV>';
		
		return;

}

// Generic error function
function paypalcart_user_error() {

    echo 'DOH!';

}

?>
