<?php
// $Id: pnuserapi.php,v 1.2 2003/06/12 07:29:29 larsneo Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Nathan Welch
// Purpose of file:  PayPalCart user API
// ----------------------------------------------------------------------


// Get information for a product
function paypalcart_userapi_getproduct($arg) {

    $items = array();

    // Security check
		if (!pnSecAuthAction(0, 'PayPalCart::', '::', ACCESS_READ)) {
        return $items;
    }

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		
    // Get the category table & column names
    $ppc_categories_table = $pntable['paypalcart_categories'];
    $ppc_categories_column = &$pntable['paypalcart_categories_column'];		

    $ppc_items_table = $pntable['paypalcart_items'];
    $ppc_items_column = &$pntable['paypalcart_items_column'];

    // Get item information
		$sql = "SELECT $ppc_items_column[pid], $ppc_items_column[cid], $ppc_items_column[name], $ppc_items_column[sku], $ppc_items_column[desc],
		               $ppc_items_column[amount], $ppc_items_column[option1], $ppc_items_column[option2], $ppc_items_column[shipping], 
									 $ppc_items_column[shipping2], $ppc_items_column[handling], $ppc_items_column[active], $ppc_items_column[image_th], 
									 $ppc_items_column[image], $ppc_items_column[order] FROM $ppc_items_table, $ppc_categories_table WHERE $ppc_items_column[active] = '1' 
		        AND $ppc_categories_column[active] = '1' AND $ppc_items_column[cid] = $ppc_categories_column[cid] AND $ppc_items_column[pid] = $arg";
    $result = $dbconn->Execute($sql);

		
    // Check for an error with the database code
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _PPC_GETFAILED);
        return false;
    }
		
    list($pid, $cid, $prod_name, $sku, $desc, $amount, $option1, $option2,
		     $shipping, $shipping2, $handling, $active, $image_th, $image, $order) = $result->fields;


		$prod_name = str_replace("\'","'",$prod_name);	
		$desc = str_replace("\'","'",$desc);	
    
		$items = array('pid' => $pid,
						      						'cid' => $cid,
                             'prod_name' => $prod_name,
                             'sku' => $sku,	
                             'desc' => $desc,	
                             'amount' => $amount,	
                             'option1' => $option1,	
                             'option2' => $option2,		
                             'shipping' => $shipping,	
                             'shipping2' => $shipping2,		
                             'handling' => $handling,		
                             'active' => $active,		
                             'image_th' => $image_th,																 														 														 														 														 												 														 														 														 													 
                             'image' => $image,
                             'order' => $order);

    $result->Close();
		
    // Return the items
    return $items;
}


?>
